<script setup lang="ts">
import { ref, type Ref } from 'vue'
import axios from "axios"

const backendURL = import.meta.env.VITE_BACKEND_URL

const error = ref('')

const errorMessages = new Map([[401, "Mohon berikan file yang benar"],
[404, "Maaf, layanan sedang tidak tersedia"],
[500, "Maaf, ada kesalahan server"]])
const unknownErrorMessage: string = "Maaf, terjadi kesalahan yang tidak diketahui"

const clear = () => { error.value = '' }
const ocrOutput = ref('Hasil OCR')
const defaultImgInputMessage = 'Unggah gambar'
const defaultPDFInputMessage = 'Unggah PDF'
const ocrInputImageFilename = ref(defaultImgInputMessage)
const ocrInputPDFFilename = ref(defaultPDFInputMessage)
const maxFileLength = 20;
const filenameTrimmer = (filename: string): string => {
  if (filename.length > maxFileLength) {
    const extLength = filename.length - filename.lastIndexOf(".") - 1;
    return filename
      .substring(0, maxFileLength - extLength)
      .concat("...")
      .concat(filename
        .substring(filename.length - extLength))
  } else {
    return filename
  }
}
const noFileErrMessage: string = "Tidak ada file"

const getFile = (e: Event) =>
  (<HTMLInputElement>e?.target).files?.[0]

const changeName = (ref: Ref<string>, filename: string) => {
  ref.value = filenameTrimmer(filename)
}

const upload = (file: File, to: string) => {
  const formData = new FormData()
  formData.append("file", file)
  const res = axios({
    method: "post",
    url: `${backendURL}/ocr/${to}`,
    data: formData,
    headers: { "Content-Type": "multipart/form-data" },
  }).then((res) => {
    ocrOutput.value = res.data.result;
  }).catch((err) => {
    error.value = errorMessages.get(err.response.status) ?? unknownErrorMessage
  });

}

const uploadImage = (e: Event) => {
  const file: File | undefined = getFile(e)
  changeName(ocrInputImageFilename, file?.name ?? noFileErrMessage)
  changeName(ocrInputPDFFilename, defaultPDFInputMessage)
  if (file) {
    upload(file, "img")
  }
}

const uploadPDF = async (e: Event) => {
  const file: File | undefined = getFile(e)
  changeName(ocrInputPDFFilename, file?.name ?? noFileErrMessage)
  changeName(ocrInputImageFilename, defaultImgInputMessage)
  if (file) {
    upload(file, "pdf")
  }
}
// from https://stackoverflow.com/a/64908345
const download = (content: string, mimeType: string, filename: string) => {
  const a = document.createElement('a')
  const blob = new Blob([content], { type: mimeType })
  const url = URL.createObjectURL(blob)
  a.setAttribute('href', url)
  a.setAttribute('download', filename)
  a.click()
}

const clickDownload = (e: Event) => {
  const text = ocrOutput.value
  download(text, "text/plain", "export.txt")
}
</script>

<template>
  <div class="py-4 text-center animate__animated animate__fadeIn flex flex-col">
    <p class="md:hidden text-neutral-500 mx-auto mb-1 font-medium text-5xl">
      OCR
    </p>
    <div id="error-msg" class="text-red-500 ml-8" @click="clear()" @hover="clear()">{{ error }}</div>
    <div class="flex justify-center flex-col md:flex-row mx-3">
      <div class="p-3 flex flex-row md:basis-1/3">
        <div class="ocr-box ocr-input justify-center flex flex-col md:flex-row">
          <!-- yoinked from https://stackoverflow.com/a/44277812 -->
          <div class="input-wrapper">
            <label for="img-input">
              <div class="upload-box-text">{{ ocrInputImageFilename }}</div>
              <input type="file" accept="image/*" @input="uploadImage" id="img-input">
            </label>
          </div>
          <div class="input-wrapper">
            <label for="pdf-input">
              <div class="upload-box-text">{{ ocrInputPDFFilename }}</div>
              <input type="file" accept="application/pdf" @input="uploadPDF" id="pdf-input">
            </label>
          </div>
        </div>
      </div>
      <div class="p-3 md:basis-2/3">
        <textarea class="text-white ocr-output ocr-box" disabled>{{ ocrOutput }}</textarea>

        <div class="content-start">
          <label for="txt-export">
            <div id="download-txt-button" class="text-white">Export TXT</div>
            <input type="button" @click="clickDownload" id="txt-export">
          </label>
        </div>
      </div>

    </div>
  </div>
</template>

<style>
input[type=file] {
  position: absolute;
  opacity: 0;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  z-index: 2;
  width: 100%;
}

.upload-box-text {
  width: 100%;
  position: relative;
  display: flex;
  align-items: center;
  justify-content: center;
  background: #3ED692;
  border-radius: 15px;
  z-index: 1;
  margin: auto;
  @apply my-3 text-white hover:bg-green-600 !important;
}

label {
  position: relative;
  @apply flex justify-center content-center mx-4;
}

.ocr-box {
  width: 100%;
  background: #ffffff;
  border-radius: 15px;
  @apply p-3 text-black drop-shadow;
}

.ocr-output {
  height: 30rem;
}

.ocr-input {
  margin: auto;
}

.input-wrapper {
  margin: auto;
  position: relative;
  @apply content-center
}

#error-msg {
  z-index: 10;
}
</style>
